/* source-buffer.c generated by valac 0.9.8, the Vala compiler
 * generated from source-buffer.vala, do not modify */

/* source-buffer.vala
 *
 * Copyright (C) 2008-2010 Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *   Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtksourceview/gtksourceview.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gstdio.h>
#include <gtksourceview/gtksourcelanguagemanager.h>


#define VALIDE_TYPE_SOURCE_BUFFER (valide_source_buffer_get_type ())
#define VALIDE_SOURCE_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SOURCE_BUFFER, ValideSourceBuffer))
#define VALIDE_SOURCE_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SOURCE_BUFFER, ValideSourceBufferClass))
#define VALIDE_IS_SOURCE_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SOURCE_BUFFER))
#define VALIDE_IS_SOURCE_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SOURCE_BUFFER))
#define VALIDE_SOURCE_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SOURCE_BUFFER, ValideSourceBufferClass))

typedef struct _ValideSourceBuffer ValideSourceBuffer;
typedef struct _ValideSourceBufferClass ValideSourceBufferClass;
typedef struct _ValideSourceBufferPrivate ValideSourceBufferPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ValideSourceBuffer {
	GtkSourceBuffer parent_instance;
	ValideSourceBufferPrivate * priv;
};

struct _ValideSourceBufferClass {
	GtkSourceBufferClass parent_class;
};

struct _ValideSourceBufferPrivate {
	char* _path;
	char* _encoding;
};


static gpointer valide_source_buffer_parent_class = NULL;

GType valide_source_buffer_get_type (void) G_GNUC_CONST;
#define VALIDE_SOURCE_BUFFER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_SOURCE_BUFFER, ValideSourceBufferPrivate))
enum  {
	VALIDE_SOURCE_BUFFER_DUMMY_PROPERTY,
	VALIDE_SOURCE_BUFFER_PATH,
	VALIDE_SOURCE_BUFFER_ENCODING
};
char* valide_source_buffer_get_buffer_contents (ValideSourceBuffer* self);
char* valide_source_buffer_get_contents (ValideSourceBuffer* self, GError** error);
char* valide_encoding_to_utf8 (const char* path, char** encoding, GError** error);
const char* valide_source_buffer_get_path (ValideSourceBuffer* self);
void valide_source_buffer_set_contents (ValideSourceBuffer* self, const char* new_path, GError** error);
char* valide_encoding_from_utf8 (GtkTextBuffer* text_buffer, char** encoding, GError** error);
void valide_source_buffer_set_path (ValideSourceBuffer* self, const char* value);
char* valide_source_buffer_get_last_word_and_iter (ValideSourceBuffer* self, GtkTextIter* start_word, GtkTextIter* end_word);
gboolean valide_utils_char_is_separator (gunichar ch);
char* valide_source_buffer_get_last_word (ValideSourceBuffer* self);
void valide_source_buffer_replace_actual_word (ValideSourceBuffer* self, const char* text);
char* valide_source_buffer_get_uri (ValideSourceBuffer* self);
char* valide_source_buffer_get_short_name_for_display (ValideSourceBuffer* self);
gboolean valide_source_buffer_is_untouched (ValideSourceBuffer* self);
ValideSourceBuffer* valide_source_buffer_new (void);
ValideSourceBuffer* valide_source_buffer_construct (GType object_type);
const char* valide_source_buffer_get_encoding (ValideSourceBuffer* self);
void valide_source_buffer_set_encoding (ValideSourceBuffer* self, const char* value);
static void valide_source_buffer_finalize (GObject* obj);
static void valide_source_buffer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void valide_source_buffer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



/**
   * Return the content of the buffer
   *
   * @return The content of the buffer
   */
#line 64 "source-buffer.vala"
char* valide_source_buffer_get_buffer_contents (ValideSourceBuffer* self) {
#line 104 "source-buffer.c"
	char* result = NULL;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
#line 64 "source-buffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "source-buffer.vala"
	gtk_text_buffer_get_bounds ((GtkTextBuffer*) self, &start, &end);
#line 112 "source-buffer.c"
	result = g_strdup (gtk_text_buffer_get_text ((GtkTextBuffer*) self, &start, &end, FALSE));
#line 69 "source-buffer.vala"
	return result;
#line 116 "source-buffer.c"
}


/**
   * Return the entire file content in UTF-8 encoding
   *
   * @return The content of the file
   */
#line 77 "source-buffer.vala"
char* valide_source_buffer_get_contents (ValideSourceBuffer* self, GError** error) {
#line 127 "source-buffer.c"
	char* result = NULL;
	char* contents;
	char* _tmp0_ = NULL;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	char* _tmp4_;
	GError * _inner_error_ = NULL;
#line 77 "source-buffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 138 "source-buffer.c"
	contents = NULL;
#line 81 "source-buffer.vala"
	_tmp3_ = (_tmp1_ = valide_encoding_to_utf8 (valide_source_buffer_get_path (self), &_tmp0_, &_inner_error_), self->priv->_encoding = (_tmp2_ = _tmp0_, _g_free0 (self->priv->_encoding), _tmp2_), _tmp1_);
#line 142 "source-buffer.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (contents);
		return NULL;
	}
#line 81 "source-buffer.vala"
	contents = (_tmp4_ = _tmp3_, _g_free0 (contents), _tmp4_);
#line 150 "source-buffer.c"
	result = contents;
#line 82 "source-buffer.vala"
	return result;
#line 154 "source-buffer.c"
}


/**
   * Write the entire buffer content in file
   */
#line 88 "source-buffer.vala"
void valide_source_buffer_set_contents (ValideSourceBuffer* self, const char* new_path, GError** error) {
#line 163 "source-buffer.c"
	char* contents;
	char* _tmp0_ = NULL;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	char* _tmp4_;
	GError * _inner_error_ = NULL;
#line 88 "source-buffer.vala"
	g_return_if_fail (self != NULL);
#line 173 "source-buffer.c"
	contents = NULL;
#line 92 "source-buffer.vala"
	_tmp3_ = (_tmp1_ = valide_encoding_from_utf8 ((GtkTextBuffer*) self, &_tmp0_, &_inner_error_), self->priv->_encoding = (_tmp2_ = _tmp0_, _g_free0 (self->priv->_encoding), _tmp2_), _tmp1_);
#line 177 "source-buffer.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (contents);
		return;
	}
#line 92 "source-buffer.vala"
	contents = (_tmp4_ = _tmp3_, _g_free0 (contents), _tmp4_);
#line 93 "source-buffer.vala"
	if (new_path != NULL) {
#line 95 "source-buffer.vala"
		valide_source_buffer_set_path (self, new_path);
#line 189 "source-buffer.c"
	}
#line 97 "source-buffer.vala"
	g_file_set_contents (valide_source_buffer_get_path (self), contents, (gssize) (-1), &_inner_error_);
#line 193 "source-buffer.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (contents);
		return;
	}
	_g_free0 (contents);
}


/**
   * Get the last word before the corsor
   *
   * @param start_word The iter at begining of the word
   * @param start_word The iter at end of the word
   *
   * @return the last word
   */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 108 "source-buffer.vala"
char* valide_source_buffer_get_last_word_and_iter (ValideSourceBuffer* self, GtkTextIter* start_word, GtkTextIter* end_word) {
#line 218 "source-buffer.c"
	char* result = NULL;
	gboolean found = FALSE;
	gunichar ch = 0U;
	char* text;
	gboolean no_doc_start = FALSE;
	GtkTextIter actual = {0};
	GtkTextIter start_iter = {0};
	GtkTextMark* insert_mark;
	GtkTextMark* _tmp0_;
#line 108 "source-buffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 230 "source-buffer.c"
	text = NULL;
	insert_mark = NULL;
#line 119 "source-buffer.vala"
	insert_mark = (_tmp0_ = _g_object_ref0 (gtk_text_buffer_get_insert ((GtkTextBuffer*) self)), _g_object_unref0 (insert_mark), _tmp0_);
#line 120 "source-buffer.vala"
	gtk_text_buffer_get_iter_at_mark ((GtkTextBuffer*) self, &actual, insert_mark);
#line 122 "source-buffer.vala"
	start_iter = actual;
#line 123 "source-buffer.vala"
	found = FALSE;
#line 241 "source-buffer.c"
	{
		gboolean _tmp1_;
#line 125 "source-buffer.vala"
		_tmp1_ = TRUE;
#line 125 "source-buffer.vala"
		while (TRUE) {
#line 125 "source-buffer.vala"
			if (!_tmp1_) {
#line 132 "source-buffer.vala"
				if (!gtk_text_iter_forward_char (&actual)) {
#line 132 "source-buffer.vala"
					break;
#line 254 "source-buffer.c"
				}
			}
#line 125 "source-buffer.vala"
			_tmp1_ = FALSE;
#line 127 "source-buffer.vala"
			ch = gtk_text_iter_get_char (&actual);
#line 128 "source-buffer.vala"
			if (valide_utils_char_is_separator (ch)) {
#line 130 "source-buffer.vala"
				break;
#line 265 "source-buffer.c"
			}
		}
	}
#line 133 "source-buffer.vala"
	*end_word = actual;
#line 135 "source-buffer.vala"
	while (TRUE) {
#line 135 "source-buffer.vala"
		if (!((no_doc_start = gtk_text_iter_backward_char (&start_iter)) == TRUE)) {
#line 135 "source-buffer.vala"
			break;
#line 277 "source-buffer.c"
		}
#line 137 "source-buffer.vala"
		ch = gtk_text_iter_get_char (&start_iter);
#line 139 "source-buffer.vala"
		if (valide_utils_char_is_separator (ch)) {
#line 141 "source-buffer.vala"
			found = TRUE;
#line 142 "source-buffer.vala"
			break;
#line 287 "source-buffer.c"
		}
	}
#line 146 "source-buffer.vala"
	if (!no_doc_start) {
#line 292 "source-buffer.c"
		char* _tmp2_;
#line 148 "source-buffer.vala"
		gtk_text_buffer_get_start_iter ((GtkTextBuffer*) self, &start_iter);
#line 149 "source-buffer.vala"
		text = (_tmp2_ = g_strdup (gtk_text_iter_get_text (&start_iter, &actual)), _g_free0 (text), _tmp2_);
#line 298 "source-buffer.c"
	} else {
#line 153 "source-buffer.vala"
		if (found) {
#line 302 "source-buffer.c"
			char* _tmp3_;
#line 155 "source-buffer.vala"
			gtk_text_iter_forward_char (&start_iter);
#line 156 "source-buffer.vala"
			text = (_tmp3_ = g_strdup (gtk_text_iter_get_text (&start_iter, &actual)), _g_free0 (text), _tmp3_);
#line 308 "source-buffer.c"
		} else {
			char* _tmp4_;
#line 160 "source-buffer.vala"
			start_iter = actual;
#line 161 "source-buffer.vala"
			text = (_tmp4_ = g_strdup (""), _g_free0 (text), _tmp4_);
#line 315 "source-buffer.c"
		}
	}
#line 164 "source-buffer.vala"
	*start_word = start_iter;
#line 320 "source-buffer.c"
	result = text;
	_g_object_unref0 (insert_mark);
#line 165 "source-buffer.vala"
	return result;
#line 325 "source-buffer.c"
}


/**
   * Get the last word before the cursor
   *
   * @return the last word
   */
#line 173 "source-buffer.vala"
char* valide_source_buffer_get_last_word (ValideSourceBuffer* self) {
#line 336 "source-buffer.c"
	char* result = NULL;
	GtkTextIter end = {0};
	GtkTextIter start = {0};
#line 173 "source-buffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 342 "source-buffer.c"
	result = valide_source_buffer_get_last_word_and_iter (self, &start, &end);
#line 178 "source-buffer.vala"
	return result;
#line 346 "source-buffer.c"
}


/**
   * Replace the current work
   *
   * @param text The new text
   */
#line 186 "source-buffer.vala"
void valide_source_buffer_replace_actual_word (ValideSourceBuffer* self, const char* text) {
#line 357 "source-buffer.c"
	GtkTextMark* mark;
	GtkTextIter word_end = {0};
	GtkTextIter word_start = {0};
	char* _tmp0_;
	GtkTextMark* _tmp1_;
#line 186 "source-buffer.vala"
	g_return_if_fail (self != NULL);
#line 186 "source-buffer.vala"
	g_return_if_fail (text != NULL);
#line 367 "source-buffer.c"
	mark = NULL;
#line 192 "source-buffer.vala"
	gtk_text_buffer_begin_user_action ((GtkTextBuffer*) self);
#line 193 "source-buffer.vala"
	_tmp0_ = valide_source_buffer_get_last_word_and_iter (self, &word_start, &word_end);
#line 373 "source-buffer.c"
	_g_free0 (_tmp0_);
#line 195 "source-buffer.vala"
	mark = (_tmp1_ = _g_object_ref0 (gtk_text_buffer_create_mark ((GtkTextBuffer*) self, "temp_replace", &word_start, TRUE)), _g_object_unref0 (mark), _tmp1_);
#line 196 "source-buffer.vala"
	gtk_text_buffer_delete ((GtkTextBuffer*) self, &word_start, &word_end);
#line 197 "source-buffer.vala"
	gtk_text_buffer_get_iter_at_mark ((GtkTextBuffer*) self, &word_start, mark);
#line 198 "source-buffer.vala"
	gtk_text_buffer_insert ((GtkTextBuffer*) self, &word_start, text, -1);
#line 199 "source-buffer.vala"
	gtk_text_buffer_delete_mark ((GtkTextBuffer*) self, mark);
#line 200 "source-buffer.vala"
	gtk_text_buffer_end_user_action ((GtkTextBuffer*) self);
#line 387 "source-buffer.c"
	_g_object_unref0 (mark);
}


/**
   * For compatibility with Gedit.Document
   */
#line 206 "source-buffer.vala"
char* valide_source_buffer_get_uri (ValideSourceBuffer* self) {
#line 397 "source-buffer.c"
	char* result = NULL;
#line 206 "source-buffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "source-buffer.vala"
	if (valide_source_buffer_get_path (self) != NULL) {
#line 403 "source-buffer.c"
		result = g_strdup_printf ("file://%s", valide_source_buffer_get_path (self));
#line 210 "source-buffer.vala"
		return result;
#line 407 "source-buffer.c"
	} else {
		result = NULL;
#line 214 "source-buffer.vala"
		return result;
#line 412 "source-buffer.c"
	}
}


/**
   * For compatibility with Gedit.Document
   *
   * @todo
   */
#line 223 "source-buffer.vala"
char* valide_source_buffer_get_short_name_for_display (ValideSourceBuffer* self) {
#line 424 "source-buffer.c"
	char* result = NULL;
#line 223 "source-buffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 428 "source-buffer.c"
	result = g_strdup (valide_source_buffer_get_path (self));
#line 225 "source-buffer.vala"
	return result;
#line 432 "source-buffer.c"
}


/**
   * For compatibility with Gedit.Document
   */
#line 231 "source-buffer.vala"
gboolean valide_source_buffer_is_untouched (ValideSourceBuffer* self) {
#line 441 "source-buffer.c"
	gboolean result = FALSE;
#line 231 "source-buffer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 445 "source-buffer.c"
	result = !gtk_text_buffer_get_modified ((GtkTextBuffer*) self);
#line 233 "source-buffer.vala"
	return result;
#line 449 "source-buffer.c"
}


#line 22 "source-buffer.vala"
ValideSourceBuffer* valide_source_buffer_construct (GType object_type) {
#line 455 "source-buffer.c"
	ValideSourceBuffer * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 22 "source-buffer.vala"
ValideSourceBuffer* valide_source_buffer_new (void) {
#line 22 "source-buffer.vala"
	return valide_source_buffer_construct (VALIDE_TYPE_SOURCE_BUFFER);
#line 466 "source-buffer.c"
}


const char* valide_source_buffer_get_path (ValideSourceBuffer* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_path;
#line 32 "source-buffer.vala"
	return result;
#line 476 "source-buffer.c"
}


void valide_source_buffer_set_path (ValideSourceBuffer* self, const char* value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 37 "source-buffer.vala"
	if (value != NULL) {
#line 485 "source-buffer.c"
		GtkSourceLanguage* lang;
		GtkSourceLanguageManager* manager;
		GtkSourceLanguageManager* _tmp0_;
		GtkSourceLanguage* _tmp1_;
		lang = NULL;
		manager = NULL;
#line 42 "source-buffer.vala"
		manager = (_tmp0_ = _g_object_ref0 (gtk_source_language_manager_get_default ()), _g_object_unref0 (manager), _tmp0_);
#line 43 "source-buffer.vala"
		lang = (_tmp1_ = _g_object_ref0 (gtk_source_language_manager_guess_language (manager, value, NULL)), _g_object_unref0 (lang), _tmp1_);
#line 44 "source-buffer.vala"
		gtk_source_buffer_set_language ((GtkSourceBuffer*) self, lang);
#line 498 "source-buffer.c"
		_g_object_unref0 (manager);
		_g_object_unref0 (lang);
	}
#line 46 "source-buffer.vala"
	self->priv->_path = (_tmp2_ = g_strdup (value), _g_free0 (self->priv->_path), _tmp2_);
#line 504 "source-buffer.c"
	g_object_notify ((GObject *) self, "path");
}


const char* valide_source_buffer_get_encoding (ValideSourceBuffer* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_encoding;
#line 55 "source-buffer.vala"
	return result;
#line 515 "source-buffer.c"
}


void valide_source_buffer_set_encoding (ValideSourceBuffer* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_encoding = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_encoding), _tmp0_);
	g_object_notify ((GObject *) self, "encoding");
}


static void valide_source_buffer_class_init (ValideSourceBufferClass * klass) {
	valide_source_buffer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideSourceBufferPrivate));
	G_OBJECT_CLASS (klass)->get_property = valide_source_buffer_get_property;
	G_OBJECT_CLASS (klass)->set_property = valide_source_buffer_set_property;
	G_OBJECT_CLASS (klass)->finalize = valide_source_buffer_finalize;
	/**
	   * The path of the file
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_SOURCE_BUFFER_PATH, g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	   * The encoding of the buffer
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_SOURCE_BUFFER_ENCODING, g_param_spec_string ("encoding", "encoding", "encoding", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void valide_source_buffer_instance_init (ValideSourceBuffer * self) {
	self->priv = VALIDE_SOURCE_BUFFER_GET_PRIVATE (self);
}


static void valide_source_buffer_finalize (GObject* obj) {
	ValideSourceBuffer * self;
	self = VALIDE_SOURCE_BUFFER (obj);
	_g_free0 (self->priv->_path);
	_g_free0 (self->priv->_encoding);
	G_OBJECT_CLASS (valide_source_buffer_parent_class)->finalize (obj);
}


GType valide_source_buffer_get_type (void) {
	static volatile gsize valide_source_buffer_type_id__volatile = 0;
	if (g_once_init_enter (&valide_source_buffer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideSourceBufferClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_source_buffer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideSourceBuffer), 0, (GInstanceInitFunc) valide_source_buffer_instance_init, NULL };
		GType valide_source_buffer_type_id;
		valide_source_buffer_type_id = g_type_register_static (GTK_TYPE_SOURCE_BUFFER, "ValideSourceBuffer", &g_define_type_info, 0);
		g_once_init_leave (&valide_source_buffer_type_id__volatile, valide_source_buffer_type_id);
	}
	return valide_source_buffer_type_id__volatile;
}


static void valide_source_buffer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValideSourceBuffer * self;
	self = VALIDE_SOURCE_BUFFER (object);
	switch (property_id) {
		case VALIDE_SOURCE_BUFFER_PATH:
		g_value_set_string (value, valide_source_buffer_get_path (self));
		break;
		case VALIDE_SOURCE_BUFFER_ENCODING:
		g_value_set_string (value, valide_source_buffer_get_encoding (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_source_buffer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValideSourceBuffer * self;
	self = VALIDE_SOURCE_BUFFER (object);
	switch (property_id) {
		case VALIDE_SOURCE_BUFFER_PATH:
		valide_source_buffer_set_path (self, g_value_get_string (value));
		break;
		case VALIDE_SOURCE_BUFFER_ENCODING:
		valide_source_buffer_set_encoding (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




